package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFAction;
import com.sa.ibiz.demo.demo.service.WFActionService;
import com.sa.ibiz.demo.demo.service.dto.WFActionSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfaction")
public class WFActionResource
{
	@Autowired
	private WFActionService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFAction> getDraft(@Validated @RequestBody WFAction data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户操作[getDraft]操作发生错误","WFAction","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFAction> remove(@Validated @RequestBody WFAction data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户操作[remove]操作发生错误","WFAction",data.getWfactionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFAction> checkKey(@Validated @RequestBody WFAction data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户操作[checkKey]操作发生错误","WFAction",data.getWfactionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFAction> get(@Validated @PathVariable String id){
		WFAction data=new WFAction();
		data.setWfactionid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流用户操作[get]操作发生错误","WFAction",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFAction> create(@Validated @RequestBody WFAction data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户操作[create]操作发生错误","WFAction",data.getWfactionid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFAction> update(@Validated @RequestBody WFAction data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户操作[update]操作发生错误","WFAction",data.getWfactionid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFAction>> searchDefaultPage(@Validated @RequestBody WFActionSearchFilter filter){
		Page<WFAction> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFAction>> listDefault(@Validated @RequestBody WFActionSearchFilter filter){
		List<WFAction> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
